# Tugas Besar 2 Sister - CUDA

# Anggota

K02 - Kelompok 07
| NIM | Nama |
| --- | ---- |
| 13519063 | Melita |
| 13519090 | Alexander |
| 13519096 | Girvin Junod |

# Cara Kerja Program

Program akan menerima seluruh input matriks target dan matriks kernel, setelah itu, fungsi CUDA akan dijalankan yang berfungsi mengalokasikan array of matrix target, matrix kernel kedalam GPU, lalu array matrix target dan matrix target tersebut akan dicopy kedalam GPU. Setelah itu fungsi konvolusi matriks akan dijalankan, skema yang paralelisasi yang digunakan adalah multiple block dan multiple thread dengan pembagian 1 block untuk minimal 1 perhitungan matriks kernel dan 1 matrix target, dengan pembagian thread untuk minimal 1 perhitungan konvolusi untuk setiap sub-matrix yang ada. Ketika jumlah matriks target melebihi jumlah blok, maka matriks tersebut akan dialokasikan sesuai dengan block yang ada (jika sudah sampai block terakhir, matriks tersebut akan diprogram pada block pertama), hal berikut juga sama dengan thread.

Setelah fungsi konvolusi dijalankan, akan dihasilkan suatu array of matrix yang berisikan matrix yang sudah dikonvolusi. Array of matrix tersebut akan dimasukan pada fungsi getDataRangeArray, untuk mengembalikan array yang berisikan data range dari setiap matriks konvolusi yang ada. Skema paralelisasi yang digunakan adalah 1 block, dengan multiple thread (1 Dimensi), 1 thread akan meng-handle minimal 1 pencarian data range dari 1 matriks konvolusi.

Setelah fungsi getDataRangeArray dijalankan, akan dihasilkan suatu array of integer yang berisikan data range dari setiap matrix konvolusi, setelah itu akan dilakukan merge sort. Skema paralelisasi yang digunakan adalah 1 block dan multiple thread, dengan pembagian setiap thread akan mendapatkan minimal 2 elemen, dan akan terus dilakukan merge array (2 sorted array), hingga seluruh elemen ada dalam pada 1 array (sorted).

Langkah terakhir lakukan copy kembali data hasil merge sort dari GPU kedalam CPU, setelah itu lakukan free() terhadap variabel variabel yang sudah tidak lagi digunakan untuk meningkatkan efektivitas memori.

# Perbandingan dan Analisis

| Test Case | Waktu Terbaik Serial (detik) | Waktu Terbaik Paralel (detik) |
| --------- | ---------------------------- | ----------------------------- |
| TC1       | 0.010470                     | 0.134379                      |
| TC2       | 0.823485                     | 0.501233                      |
| TC3       | 0.833403                     | 0.612360                      |
| TC4       | 10.478817                    | 3.792444                      |

Dapat dilihat dari hasil di atas bahwa program paralel lebih cepat dari program serial untuk semua test case kecuali TC1. Ini dikarenakan program paralel dapat melakukan berbagai perhitungan sekaligus, sehingga secara teori waktu eksekusinya harusnya lebih cepat dari program serial. Namun, perlu diperhatikan juga pada program paralel dibutuhkan waktu untuk komunikasi, transfer data antar mesin, dan biaya lainnya yang muncul akibat paralelisasi. Ini membuat perbedaan waktu antara program serial dan paralel tidak begitu signifikan sampai jumlah data yang harus diolah itu cukup besar sehingga paralelisasi dari program paralel dapat memberikan waktu eksekusi yang lebih cepat secara signifikan.

Dapat dilihat dari tabel di atas, untuk testcase dengan data yang sedikit yaitu TC1, waktu eksekusi secara serial lebih cepat, sementara pada data dalam jumlah besar yaitu TC4, eksekusi secara paralel jauh lebih cepat.

# Perbedaan Hasil Serial dan Paralel

Hasil eksekusi program serial dan paralel seharusnya memiliki hasil keluaran yang sama. Yang berbeda adalah waktu yang dibutuhkan untuk eksekusi program serial dan paralel. Perbedaan waktu ini diakibatkan perbedaan cara eksekusi program serial dan paralel, namun perbedaan ini seharusnya tidak akan mengakibatkan perbedaan hasil keluaran.

# Perhitungan Waktu Eksekusi Untuk Beberapa Kasus

| Jumlah Matrix | Ukuran Kernel | Ukuran Matrix | Waktu Eksekusi (Detik) |
| ------------- | ------------- | ------------- | ---------------------- |
| 10000         | 1x1           | 1x1           | 0.154368               |
| 1             | 1x1           | 100x100       | 0.124067               |
| 1             | 100x100       | 100x100       | 0.141902               |

Untuk perbandingan ini, kami melakukan beberapa eksekusi program menggunakan TC buatan kami untuk memenuhi ketentuan yang ada. Dapat dilihat di atas hasil dari eksperimen yang kami lakukan.

Pada kasus pertama, skema paralelisasi yang digunakan hanya pada block, dikarenakan karena ukuran matrix dan kernal 1x1, maka setiap block hanya akan digunakan 1 thread saja.

Pada kasus kedua, skema paralelisasi yang digunakan hanya pada thread, dikarenakan jumlah matrixnya hanya 1, maka 1 matrix tersebut akan dihandle pada 1 block.

Pada kasus ketiga, tidak ada skema paralelisasi yang digunakan, dikarenakan pembagian 1 block untuk 1 matrix, dan 1 thread untuk 1 perhitungan konvolusi (Hasil Matrix konvolusi berukuran 1x1). Maka dari itu kasus ketiga dijalankan secara serial.

Dari ketiga kasus tersebut, dapat dilihat kasus kedua memiliki waktu yang tercepat, dikarenakan jumlah thread yang digunakan merupakan thread 2D, sehingga jika jumlah thread yang di-input adalah 16, maka thread yang digunakan dalam skema paralelisasi adalah 16x16 = 256 Thread.

Tentunya waktu eksekusi dari program juga tidak konstan dan dapat berubah pada setiap eksekusi tergantung banyak faktor di luar kode dan input. Sehingga waktu yang ditampilkan di sini dapat berubah pada eksekusi lain dan urutan waktu kecepatannya juga dapat berbeda saat eksekusi lain. Namun, dari berbagai eksekusi yang kami lakukan urutan kecepatannya cenderung sesuai dengan yang ditunjukkan di atas sehingga menurut kami hasil di atas cukup menggambarkan pengaruh jumlah matrix, ukuran kernel, dan ukuran matrix pada waktu eksekusi. 
